/* ======================================================================================================== //
// the process of IEC60730 Class B
// ======================================================================================================== */
static void f_iec60730_class_b_startup_sram( void)
{
	{// to proof private SRAM is okay
		f_iec60730_class_b_initial_sram();	// to reset when private SRAM testing failed
	}
	{// to check whole SRAM base on runtime program
		r_iec60730.sram.addr = d_ice60730_class_b_sram_start_address;
		f_iec60730_class_b_runtime_sram();
		while( r_iec60730.sram.addr > d_ice60730_class_b_sram_start_address )
		{
			f_iec60730_class_b_runtime_sram();
		}
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_runtime_sram( void)
{
	if ( r_iec60730.share.result.bit.sram == 0 )
	{
		{// backup
			for (	r_iec60730.sram.index = 0,
					r_iec60730.share.addr[0] = r_iec60730.sram.addr;
					r_iec60730.sram.index < (sizeof(r_iec60730.share.buf)/sizeof(r_iec60730.share.buf[0]));
					r_iec60730.sram.index++	)
			{
				{// make sure the current address of sram is legal
					if ( r_iec60730.sram.addr < d_ice60730_class_b_sram_start_address )
					{
						r_iec60730.share.result.bit.sram = 1;	// too small
						return;
					}
					if ( r_iec60730.sram.addr > d_ice60730_class_b_sram_stop_address )
					{
						r_iec60730.share.result.bit.sram = 1;	// too big
						return;
					}
					if ( r_iec60730.sram.addr >= (&r_iec60730) )
					{
						if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
						{
							r_iec60730.sram.addr = (&r_iec60730 + 1);
						}
					}
				}
				{// save the data from user ram
					r_iec60730.share.buf[r_iec60730.sram.index] = r_iec60730.sram.addr[0];
				}
				{// take next address
					r_iec60730.sram.addr++;
					if ( r_iec60730.sram.addr > d_ice60730_class_b_sram_stop_address )
					{
						// r_iec60730.sram.addr = d_ice60730_class_b_sram_start_address;
						r_iec60730.sram.index++;
						break;
					}
				}
			}
		}
		{// check pointer
			// r_iec60730.share.addr[0] 						// start address of USER RAM
			r_iec60730.share.addr[1] = r_iec60730.sram.addr;	// last address of USER RAM
		}
		{// to qualify user ram
			{// ascending order //
				for (	r_iec60730.sram.index = 0;
						r_iec60730.sram.index < (sizeof(a_iec60730_class_b_march_c_1_byte)/sizeof(a_iec60730_class_b_march_c_1_byte[0]));
						r_iec60730.sram.index++	)
				{
					// write //
					for (	r_iec60730.sram.addr = r_iec60730.share.addr[0];
							r_iec60730.sram.addr < r_iec60730.share.addr[1];
							r_iec60730.sram.addr++	)
					{
						if ( r_iec60730.sram.addr >= (&r_iec60730) )
						{
							if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
							{
								r_iec60730.sram.addr = (&r_iec60730 + 1);
							}
						}
						r_iec60730.sram.addr[0] = a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index];
					}
					// read //
					for (	r_iec60730.sram.addr = r_iec60730.share.addr[0];
							r_iec60730.sram.addr < r_iec60730.share.addr[1];
							r_iec60730.sram.addr++	)
					{
						if ( r_iec60730.sram.addr >= (&r_iec60730) )
						{
							if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
							{
								r_iec60730.sram.addr = (&r_iec60730 + 1);
							}
						}
						if ( r_iec60730.sram.addr[0] != a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index] )
						{
							r_iec60730.share.result.bit.sram = 1;	// the testing is failed
							// break;
						}
					}
				}
			}
			{// descending order //
				for (	r_iec60730.sram.index = 0;
						r_iec60730.sram.index < (sizeof(a_iec60730_class_b_march_c_1_byte)/sizeof(a_iec60730_class_b_march_c_1_byte[0]));
						r_iec60730.sram.index++	)
				{
					// write //
					for (	r_iec60730.sram.addr = r_iec60730.share.addr[1],
							r_iec60730.sram.addr--;
							r_iec60730.sram.addr >= r_iec60730.share.addr[0];
							r_iec60730.sram.addr--	)
					{
						if ( r_iec60730.sram.addr >= (&r_iec60730) )
						{
							if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
							{
								r_iec60730.sram.addr = (&r_iec60730);
								r_iec60730.sram.addr--;
							}
						}
						r_iec60730.sram.addr[0] = a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index];
					}
					// read //
					for (	r_iec60730.sram.addr = r_iec60730.share.addr[1],
							r_iec60730.sram.addr--;
							r_iec60730.sram.addr >= r_iec60730.share.addr[0];
							r_iec60730.sram.addr--	)
					{
						if ( r_iec60730.sram.addr >= (&r_iec60730) )
						{
							if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
							{
								r_iec60730.sram.addr = (&r_iec60730);
								r_iec60730.sram.addr--;
							}
						}
						if ( r_iec60730.sram.addr[0] != a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index] )
						{
							r_iec60730.share.result.bit.sram = 1;	// the testing is failed
							// break;
						}
					}
				}
			}
		}
		{// resume
			for (	r_iec60730.sram.index = 0,
					r_iec60730.sram.addr = r_iec60730.share.addr[0];
					r_iec60730.sram.addr < r_iec60730.share.addr[1];
					r_iec60730.sram.addr++,
					r_iec60730.sram.index++ )
			{
				if ( r_iec60730.sram.addr >= (&r_iec60730) )
				{
					if ( r_iec60730.sram.addr < (&r_iec60730 + 1) )
					{
						r_iec60730.sram.addr = (&r_iec60730 + 1);
					}
				}
				r_iec60730.sram.addr[0] = r_iec60730.share.buf[r_iec60730.sram.index];
			}
		}
		{// control the limit
			if ( r_iec60730.share.addr[1] > d_ice60730_class_b_sram_stop_address )
			{
				r_iec60730.sram.addr = d_ice60730_class_b_sram_start_address;
			}
		}
	}
}



/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_initial_sram( void)
{// process of SRAM
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// To proof SRAM of index and address both are okay
	while(1)
	{// proof SRAM of index
		r_iec60730.sram.index		 = 0x00;
		if ( r_iec60730.sram.index	== 0x00 )
		{
			r_iec60730.sram.index		 = 0x11;
			if ( r_iec60730.sram.index	== 0x11 )
			{
				r_iec60730.sram.index		 = 0x22;
				if ( r_iec60730.sram.index	== 0x22 )
				{
					r_iec60730.sram.index		 = 0x44;
					if ( r_iec60730.sram.index	== 0x44 )
					{
						r_iec60730.sram.index		 = 0x88;
						if ( r_iec60730.sram.index	== 0x88 )
						{
							r_iec60730.sram.index		 = 0xcc;
							if ( r_iec60730.sram.index	== 0xcc )
							{
								r_iec60730.sram.index		 = 0xee;
								if ( r_iec60730.sram.index	== 0xee )
								{
									r_iec60730.sram.index		 = 0x66;
									if ( r_iec60730.sram.index	== 0x66 )
									{
										r_iec60730.sram.index		 = 0x77;
										if ( r_iec60730.sram.index	== 0x77 )
										{
											r_iec60730.sram.index		 = 0x33;
											if ( r_iec60730.sram.index	== 0x33 )
											{
												r_iec60730.sram.index		 = 0x55;
												if ( r_iec60730.sram.index	== 0x55 )
												{
													r_iec60730.sram.index		 = 0xaa;
													if ( r_iec60730.sram.index	== 0xaa )
													{
														r_iec60730.sram.index		 = 0xc3;
														if ( r_iec60730.sram.index	== 0xc3 )
														{
															r_iec60730.sram.index		 = 0xa5;
															if ( r_iec60730.sram.index	== 0xa5 )
															{
																break;
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
		f_iec60730_class_b_initial_sram_failed();	// the testing is failed
		return;
	}
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// proof SRAM of address
	for (	r_iec60730.sram.index = 0;
			r_iec60730.sram.index < (sizeof(a_iec60730_class_b_march_c_2_bytes)/sizeof(a_iec60730_class_b_march_c_2_bytes[0]));
			r_iec60730.sram.index++	)
	{
		r_iec60730.sram.addr = a_iec60730_class_b_march_c_2_bytes[r_iec60730.sram.index];
		if ( r_iec60730.sram.addr != a_iec60730_class_b_march_c_2_bytes[r_iec60730.sram.index] )
		{
			f_iec60730_class_b_initial_sram_failed();	// the testing is failed
			return;
		}
	}
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ //
	// To proof SRAM of IEC60730 is okay
	// ascending order //
	for (	r_iec60730.sram.index = 0;
			r_iec60730.sram.index < (sizeof(a_iec60730_class_b_march_c_1_byte)/sizeof(a_iec60730_class_b_march_c_1_byte[0]));
			r_iec60730.sram.index++	)
	{
		// write //
		for (	r_iec60730.sram.addr = (&r_iec60730),
				r_iec60730.sram.addr = (r_iec60730.sram.addr + 3);
				r_iec60730.sram.addr < (&r_iec60730 + 1);
				r_iec60730.sram.addr++	)
		{
			r_iec60730.sram.addr[0] = a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index];
		}
		// read //
		for (	r_iec60730.sram.addr = (&r_iec60730 ),
				r_iec60730.sram.addr = (r_iec60730.sram.addr + 3);
				r_iec60730.sram.addr < (&r_iec60730 + 1);
				r_iec60730.sram.addr++	)
		{
			if ( r_iec60730.sram.addr[0] != a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index] )
			{
				f_iec60730_class_b_initial_sram_failed();	// the testing is failed
				return;
			}
		}
	}
	// descending order //
	for (	r_iec60730.sram.index = 0;
			r_iec60730.sram.index < (sizeof(a_iec60730_class_b_march_c_1_byte)/sizeof(a_iec60730_class_b_march_c_1_byte[0]));
			r_iec60730.sram.index++	)
	{
		// write //
		for (	r_iec60730.sram.addr = (&r_iec60730 + 1),
				r_iec60730.sram.addr--;
				r_iec60730.sram.addr - 2 > &r_iec60730;
				r_iec60730.sram.addr-- )
		{
			r_iec60730.sram.addr[0] = a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index];
		}
		// read //
		for (	r_iec60730.sram.addr = (&r_iec60730 + 1),
				r_iec60730.sram.addr--;
				r_iec60730.sram.addr - 2 > &r_iec60730;
				r_iec60730.sram.addr-- )
		{
			if ( r_iec60730.sram.addr[0] != a_iec60730_class_b_march_c_1_byte[r_iec60730.sram.index] )
			{
				f_iec60730_class_b_initial_sram_failed();	// the testing is failed
				return;
			}
		}
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_initial_sram_failed( void)
{
	r_iec60730.share.result.buf = 0xff;
	if ( r_iec60730.share.result.buf == 0 )
	{
		f_iec60730_go_reset();	// result buffer is dead and then go to reset.
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
